Index: lab3/.depend
===================================================================
--- lab3/.depend	(revision 31)
+++ lab3/.depend	(nonexistent)
@@ -1,135 +0,0 @@
-kbc.d kbc.ln kbc.o: kbc.c /usr/include/lcom/lcf.h /usr/include/stdbool.h \
-  /usr/include/stdio.h /usr/include/sys/cdefs.h \
-  /usr/include/machine/cdefs.h /usr/include/sys/cdefs_elf.h \
-  /usr/include/sys/featuretest.h /usr/include/sys/ansi.h \
-  /usr/include/machine/ansi.h /usr/include/machine/int_types.h \
-  /usr/include/sys/common_int_types.h /usr/include/sys/null.h \
-  /usr/include/stdlib.h /usr/include/sys/types.h \
-  /usr/include/machine/types.h /usr/include/machine/endian.h \
-  /usr/include/sys/endian.h /usr/include/machine/endian_machdep.h \
-  /usr/include/machine/bswap.h /usr/include/machine/byte_swap.h \
-  /usr/include/sys/bswap.h /usr/include/sys/stdint.h \
-  /usr/include/machine/int_mwgwtypes.h \
-  /usr/include/sys/common_int_mwgwtypes.h \
-  /usr/include/machine/int_limits.h /usr/include/sys/common_int_limits.h \
-  /usr/include/machine/int_const.h /usr/include/sys/common_int_const.h \
-  /usr/include/machine/wchar_limits.h /usr/include/sys/fd_set.h \
-  /usr/include/time.h /usr/include/sys/time.h \
-  /usr/include/sys/timespec.h /usr/include/sys/select.h \
-  /usr/include/sys/sigtypes.h /usr/include/unistd.h \
-  /usr/include/sys/unistd.h /usr/include/machine/int86.h \
-  /usr/include/minix/const.h /usr/include/machine/archconst.h \
-  /usr/include/minix/driver.h /usr/include/minix/config.h \
-  /usr/include/minix/sys_config.h /usr/include/minix/type.h \
-  /usr/include/machine/multiboot.h /usr/include/stddef.h \
-  /usr/include/machine/interrupt.h /usr/include/minix/ipc.h \
-  /usr/include/minix/ipcconst.h /usr/include/machine/ipcconst.h \
-  /usr/include/sys/signal.h /usr/include/sys/siginfo.h \
-  /usr/include/machine/signal.h /usr/include/machine/fpu.h \
-  /usr/include/machine/trap.h /usr/include/x86/trap.h \
-  /usr/include/sys/ucontext.h /usr/include/machine/mcontext.h \
-  /usr/include/minix/com.h /usr/include/minix/callnr.h \
-  /usr/include/minix/syslib.h /usr/include/minix/u64.h \
-  /usr/include/minix/devio.h /usr/include/minix/safecopies.h \
-  /usr/include/minix/vm.h /usr/include/minix/endpoint.h \
-  /usr/include/limits.h /usr/include/machine/limits.h \
-  /usr/include/sys/syslimits.h /usr/include/minix/sef.h \
-  /usr/include/minix/sysutil.h /usr/include/string.h \
-  /usr/include/strings.h /usr/include/errno.h /usr/include/sys/errno.h \
-  /usr/include/sys/param.h /usr/include/sys/inttypes.h \
-  /usr/include/machine/int_fmtio.h /usr/include/sys/common_int_fmtio.h \
-  /usr/include/machine/param.h /usr/include/minix/partition.h \
-  /usr/include/sys/mman.h /usr/include/lcom/liblm.h \
-  /usr/include/lcom/lab2.h /usr/include/lcom/timer.h \
-  /usr/include/lcom/utils.h /usr/include/lcom/lab3.h \
-  /usr/include/lcom/types.h kbc.h kbc_func.h
-lab3.d lab3.ln lab3.o: lab3.c /usr/include/lcom/lcf.h /usr/include/stdbool.h \
-  /usr/include/stdio.h /usr/include/sys/cdefs.h \
-  /usr/include/machine/cdefs.h /usr/include/sys/cdefs_elf.h \
-  /usr/include/sys/featuretest.h /usr/include/sys/ansi.h \
-  /usr/include/machine/ansi.h /usr/include/machine/int_types.h \
-  /usr/include/sys/common_int_types.h /usr/include/sys/null.h \
-  /usr/include/stdlib.h /usr/include/sys/types.h \
-  /usr/include/machine/types.h /usr/include/machine/endian.h \
-  /usr/include/sys/endian.h /usr/include/machine/endian_machdep.h \
-  /usr/include/machine/bswap.h /usr/include/machine/byte_swap.h \
-  /usr/include/sys/bswap.h /usr/include/sys/stdint.h \
-  /usr/include/machine/int_mwgwtypes.h \
-  /usr/include/sys/common_int_mwgwtypes.h \
-  /usr/include/machine/int_limits.h /usr/include/sys/common_int_limits.h \
-  /usr/include/machine/int_const.h /usr/include/sys/common_int_const.h \
-  /usr/include/machine/wchar_limits.h /usr/include/sys/fd_set.h \
-  /usr/include/time.h /usr/include/sys/time.h \
-  /usr/include/sys/timespec.h /usr/include/sys/select.h \
-  /usr/include/sys/sigtypes.h /usr/include/unistd.h \
-  /usr/include/sys/unistd.h /usr/include/machine/int86.h \
-  /usr/include/minix/const.h /usr/include/machine/archconst.h \
-  /usr/include/minix/driver.h /usr/include/minix/config.h \
-  /usr/include/minix/sys_config.h /usr/include/minix/type.h \
-  /usr/include/machine/multiboot.h /usr/include/stddef.h \
-  /usr/include/machine/interrupt.h /usr/include/minix/ipc.h \
-  /usr/include/minix/ipcconst.h /usr/include/machine/ipcconst.h \
-  /usr/include/sys/signal.h /usr/include/sys/siginfo.h \
-  /usr/include/machine/signal.h /usr/include/machine/fpu.h \
-  /usr/include/machine/trap.h /usr/include/x86/trap.h \
-  /usr/include/sys/ucontext.h /usr/include/machine/mcontext.h \
-  /usr/include/minix/com.h /usr/include/minix/callnr.h \
-  /usr/include/minix/syslib.h /usr/include/minix/u64.h \
-  /usr/include/minix/devio.h /usr/include/minix/safecopies.h \
-  /usr/include/minix/vm.h /usr/include/minix/endpoint.h \
-  /usr/include/limits.h /usr/include/machine/limits.h \
-  /usr/include/sys/syslimits.h /usr/include/minix/sef.h \
-  /usr/include/minix/sysutil.h /usr/include/string.h \
-  /usr/include/strings.h /usr/include/errno.h /usr/include/sys/errno.h \
-  /usr/include/sys/param.h /usr/include/sys/inttypes.h \
-  /usr/include/machine/int_fmtio.h /usr/include/sys/common_int_fmtio.h \
-  /usr/include/machine/param.h /usr/include/minix/partition.h \
-  /usr/include/sys/mman.h /usr/include/lcom/liblm.h \
-  /usr/include/lcom/lab2.h /usr/include/lcom/timer.h \
-  /usr/include/lcom/utils.h /usr/include/lcom/lab3.h \
-  /usr/include/lcom/types.h kbc.h kbc_func.h
-utils.d utils.ln utils.o: utils.c /usr/include/lcom/lcf.h /usr/include/stdbool.h \
-  /usr/include/stdio.h /usr/include/sys/cdefs.h \
-  /usr/include/machine/cdefs.h /usr/include/sys/cdefs_elf.h \
-  /usr/include/sys/featuretest.h /usr/include/sys/ansi.h \
-  /usr/include/machine/ansi.h /usr/include/machine/int_types.h \
-  /usr/include/sys/common_int_types.h /usr/include/sys/null.h \
-  /usr/include/stdlib.h /usr/include/sys/types.h \
-  /usr/include/machine/types.h /usr/include/machine/endian.h \
-  /usr/include/sys/endian.h /usr/include/machine/endian_machdep.h \
-  /usr/include/machine/bswap.h /usr/include/machine/byte_swap.h \
-  /usr/include/sys/bswap.h /usr/include/sys/stdint.h \
-  /usr/include/machine/int_mwgwtypes.h \
-  /usr/include/sys/common_int_mwgwtypes.h \
-  /usr/include/machine/int_limits.h /usr/include/sys/common_int_limits.h \
-  /usr/include/machine/int_const.h /usr/include/sys/common_int_const.h \
-  /usr/include/machine/wchar_limits.h /usr/include/sys/fd_set.h \
-  /usr/include/time.h /usr/include/sys/time.h \
-  /usr/include/sys/timespec.h /usr/include/sys/select.h \
-  /usr/include/sys/sigtypes.h /usr/include/unistd.h \
-  /usr/include/sys/unistd.h /usr/include/machine/int86.h \
-  /usr/include/minix/const.h /usr/include/machine/archconst.h \
-  /usr/include/minix/driver.h /usr/include/minix/config.h \
-  /usr/include/minix/sys_config.h /usr/include/minix/type.h \
-  /usr/include/machine/multiboot.h /usr/include/stddef.h \
-  /usr/include/machine/interrupt.h /usr/include/minix/ipc.h \
-  /usr/include/minix/ipcconst.h /usr/include/machine/ipcconst.h \
-  /usr/include/sys/signal.h /usr/include/sys/siginfo.h \
-  /usr/include/machine/signal.h /usr/include/machine/fpu.h \
-  /usr/include/machine/trap.h /usr/include/x86/trap.h \
-  /usr/include/sys/ucontext.h /usr/include/machine/mcontext.h \
-  /usr/include/minix/com.h /usr/include/minix/callnr.h \
-  /usr/include/minix/syslib.h /usr/include/minix/u64.h \
-  /usr/include/minix/devio.h /usr/include/minix/safecopies.h \
-  /usr/include/minix/vm.h /usr/include/minix/endpoint.h \
-  /usr/include/limits.h /usr/include/machine/limits.h \
-  /usr/include/sys/syslimits.h /usr/include/minix/sef.h \
-  /usr/include/minix/sysutil.h /usr/include/string.h \
-  /usr/include/strings.h /usr/include/errno.h /usr/include/sys/errno.h \
-  /usr/include/sys/param.h /usr/include/sys/inttypes.h \
-  /usr/include/machine/int_fmtio.h /usr/include/sys/common_int_fmtio.h \
-  /usr/include/machine/param.h /usr/include/minix/partition.h \
-  /usr/include/sys/mman.h /usr/include/lcom/liblm.h \
-  /usr/include/lcom/lab2.h /usr/include/lcom/timer.h \
-  /usr/include/lcom/utils.h /usr/include/lcom/lab3.h \
-  /usr/include/lcom/types.h

Property changes on: lab3/.depend
___________________________________________________________________
Deleted: svn:executable
Index: lab3/.gdbinit
===================================================================
--- lab3/.gdbinit	(revision 31)
+++ lab3/.gdbinit	(nonexistent)

Property changes on: lab3/.gdbinit
___________________________________________________________________
Deleted: svn:executable
Index: lab3/lab3
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/x-executable
Index: lab3/lab3
===================================================================
--- lab3/lab3	(revision 31)
+++ lab3/lab3	(nonexistent)

Property changes on: lab3/lab3
___________________________________________________________________
Deleted: svn:executable
Deleted: svn:mime-type
## -1 +0,0 ##
-application/x-executable
\ No newline at end of property