Index: proj/libs/classes/include/list.h
===================================================================
--- proj/libs/classes/include/list.h	(revision 327)
+++ proj/libs/classes/include/list.h	(revision 328)
@@ -1,13 +1,28 @@
 #ifndef LIST_H_INCLUDED
 #define LIST_H_INCLUDED
 
-struct list_node;
 /**
- * @brief List node.
+ * @defgroup    list_t    list_t
+ * @brief List module
  *
+ * Can be used like a C++ std::list.
+ * A list_t is a sequence of list_node_t nodes, that store void* to allow for more flexibility.
+ *
+ * @{
+ */
+
+/**
+ * @defgroup    list_node_t   list_node_t
+ * @ingroup list
+ * @brief List node module
+ *
  * Can be used like a C++ std::list iterator.
  * A list node stores a void* to allow for more flexibility.
+ *
+ * @{
  */
+
+struct list_node;
 typedef struct list_node list_node_t;
 
 /**
@@ -42,13 +57,12 @@
  */
 void**       (list_node_val )(list_node_t *p);
 
-struct list;
 /**
- * @brief List.
- *
- * Can be used like a C++ std::list.
- * A list_t is a sequence of list_node_t nodes, that store void* to allow for more flexibility.
+ * @}
  */
+
+struct list;
+
 typedef struct list list_t;
 
 /**
@@ -131,4 +145,8 @@
  */
 list_node_t* (list_find)     (list_t *l, void *val);
 
+/**
+ * @}
+ */
+
 #endif //LIST_H_INCLUDED
Index: proj/libs/classes/include/queue.h
===================================================================
--- proj/libs/classes/include/queue.h	(revision 327)
+++ proj/libs/classes/include/queue.h	(revision 328)
@@ -1,13 +1,18 @@
 #ifndef QUEUE_H_INCLUDED
 #define QUEUE_H_INCLUDED
 
-struct queue;
 /**
- * @brief Queue.
+ * @defgroup    queue_t queue_t
+ * @brief Queue module
  *
  * Can be used like a C++ std::queue.
  * A queue_t is an interface for a list_t that simulates a FIFO.
+ *
+ * @{
  */
+
+
+struct queue;
 typedef struct queue queue_t;
 
 /**
@@ -54,4 +59,8 @@
  */
 void     (queue_pop  )(queue_t *q);
 
+/**
+ * @}
+ */
+
 #endif //QUEUE_H_INCLUDED
Index: proj/libs/kbc/src/mouse.c
===================================================================
--- proj/libs/kbc/src/mouse.c	(revision 327)
+++ proj/libs/kbc/src/mouse.c	(revision 328)
@@ -158,7 +158,7 @@
             if((ret = util_sys_inb(OUTPUT_BUF, byte))) return ret;
             else return SUCCESS;
         }
-        tickdelay(micros_to_ticks(DELAY));
+        tickdelay(micros_to_ticks(period));
     }
 }
 
Index: proj/libs/uart/include/uart.h
===================================================================
--- proj/libs/uart/include/uart.h	(revision 327)
+++ proj/libs/uart/include/uart.h	(revision 328)
@@ -42,7 +42,7 @@
 int uart_set_bits_per_character(int base_addr, uint8_t     bits_per_char);
 int uart_set_stop_bits         (int base_addr, uint8_t     stop         );
 int uart_set_parity            (int base_addr, uart_parity par          );
-int uart_set_bit_rate          (int base_addr, double      bit_rate     );
+int uart_set_bit_rate          (int base_addr, uint32_t    bit_rate     );
 
 int uart_enable_int_rx (int base_addr);
 int uart_disable_int_rx(int base_addr);
Index: proj/libs/uart/src/uart.c
===================================================================
--- proj/libs/uart/src/uart.c	(revision 327)
+++ proj/libs/uart/src/uart.c	(revision 328)
@@ -213,7 +213,7 @@
     conf = (conf & (~UART_PARITY)) | parity;
     return uart_set_lcr(base_addr, conf);
 }
-int uart_set_bit_rate(int base_addr, double bit_rate){
+int uart_set_bit_rate(int base_addr, uint32_t bit_rate){
     int ret = SUCCESS;
     uint16_t latch = (uint16_t)(UART_BITRATE/bit_rate);
     uint8_t dll = UART_GET_DLL(latch);
Index: proj/src/ent.c
===================================================================
--- proj/src/ent.c	(revision 327)
+++ proj/src/ent.c	(revision 328)
@@ -284,8 +284,8 @@
     free(p->visited);
     free(p);
 }
-static int16_t (map_get_x_screen)(const map_t *p){ return (int16_t)((-x_origin)*scale); }
-static int16_t (map_get_y_screen)(const map_t *p){ return (int16_t)((-y_origin)*scale); }
+static int16_t (map_get_x_screen)(const map_t *p){ (void)p; return (int16_t)((-x_origin)*scale); }
+static int16_t (map_get_y_screen)(const map_t *p){ (void)p; return (int16_t)((-y_origin)*scale); }
 uint16_t (map_get_width)   (const map_t *p){ return sprite_get_w(p->background); }
 uint16_t (map_get_height)  (const map_t *p){ return sprite_get_h(p->background); }
 int (map_collides_point)(const map_t *p, double x, double y){
Index: proj/src/interrupts_func.c
===================================================================
--- proj/src/interrupts_func.c	(revision 327)
+++ proj/src/interrupts_func.c	(revision 328)
@@ -115,7 +115,7 @@
     uart_set_bits_per_character(COM1_ADDR, 8);
     uart_set_stop_bits         (COM1_ADDR, 2);
     uart_set_parity            (COM1_ADDR, uart_parity_even);
-    uart_set_bit_rate          (COM1_ADDR, 38400);
+    uart_set_bit_rate          (COM1_ADDR, 115200);
     uart_enable_int_rx (COM1_ADDR);
     uart_enable_int_tx(COM1_ADDR);
     if(subscribe_uart_interrupt(COM1_IRQ, &uart_id)) {
Index: proj/src/proj.c
===================================================================
--- proj/src/proj.c	(revision 327)
+++ proj/src/proj.c	(revision 328)
@@ -62,6 +62,7 @@
 static int (multiplayer)(void);
 static int (chat)(void);
 int(proj_main_loop)(int argc, char *argv[]) {
+    (void)argc; (void)argv;
 
     int r;
 
Index: proj/Makefile
===================================================================
--- proj/Makefile	(revision 327)
+++ proj/Makefile	(revision 328)
@@ -12,7 +12,7 @@
 SRCS= list.c queue.c graph.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c fast_math.c xpm_utils.c rtc.c uart.c makecode_map.c menu.c proj_func.c rectangle.c font.c ent.c proj.c hltp.c
 IPATHS=-I./include -I./libs/graph/include -I./libs/kbc/include -I./libs/rtc/include -I./libs/timer/include -I./libs/uart/include -I./libs/classes/include -I./libs/utils/include -I./maps -I./media/xpm
 
-CPPFLAGS += -pedantic ${IPATHS} -D LCOM_MACRO -D __LCOM_OPTIMIZED__ #-Weverything -Wno-padded -Wno-unused-macros
+CPPFLAGS += -pedantic ${IPATHS} -D LCOM_MACRO -D __LCOM_OPTIMIZED__ -Wall -Wextra -Wshadow -Wunreachable-code #-Weverything -Wno-padded -Wno-unused-macros
 
 
 DPADD += ${LIBLCF}
Index: proj/tasks.md
===================================================================
--- proj/tasks.md	(revision 327)
+++ proj/tasks.md	(revision 328)
@@ -4,6 +4,7 @@
 - [ ] Implement multiplayer 1v1 game and win condition to reach N kills.
 - [ ] Leaderboard of fastest win, or any achievement (to make use of RTC).
 - [ ] Documentation
+- [ ] Small schemes for report, generated by Doxygen
 - [ ] Report
 
 ### Mid priority